﻿Public Class Form1
    <System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.Cdecl)>
    Private Shared Function _EpwOpen(mode As Integer, extmode As Integer, writetime As Integer, ExtPower As Boolean) As Boolean
    End Function
    <System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.Cdecl)>
    Private Shared Sub _EpwClose()
    End Sub
    <System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.Cdecl)>
    Private Shared Function _EpwMode(mode As Integer, extmode As Integer, writetime As Integer) As Boolean
    End Function
    <System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.Cdecl)>
    Private Shared Function _EpwCheck() As Integer
    End Function
    <System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.Cdecl)>
    Private Shared Function _EpwRead(type As Integer, adr As Integer, dat As Byte(), len As Integer, psize As Integer) As Boolean
    End Function
    <System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.Cdecl)>
    Private Shared Function _EpwCompare(type As Integer, adr As Integer, dat As Byte(), len As Integer, psize As Integer) As Boolean
    End Function
    <System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.Cdecl)>
    Private Shared Function _EpwChecksum(type As Integer, adr As Integer, dat As Byte(), len As Integer, psize As Integer) As Integer
    End Function
    <System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.Cdecl)>
    Private Shared Function _EpwBlankChk(type As Integer, adr As Integer, dat As Byte(), len As Integer, psize As Integer) As Boolean
    End Function
    <System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.Cdecl)>
    Private Shared Function _EpwWrite(type As Integer, adr As Integer, dat As Byte(), len As Integer, psize As Integer) As Boolean
    End Function
    <System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.Cdecl)>
    Private Shared Function _EpwErase(type As Integer, adr As Integer, dat As Byte(), len As Integer, psize As Integer) As Boolean
    End Function
    <System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.Cdecl)>
    Private Shared Function _EpwDllVer() As Integer
    End Function
    <System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.Cdecl)>
    Private Shared Function _EpwFrmVer() As Integer
    End Function
    <System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.Cdecl)>
    Private Shared Function _EpwSetFreq(freq As Integer) As Boolean
    End Function
    <System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.Cdecl)>
    Private Shared Function _EpwGetFreq() As Integer
    End Function
    <System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.Cdecl)>
    Private Shared Function _EpwGetSwitch() As Integer
    End Function
    <System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.Cdecl)>
    Private Shared Sub _EpwSetEvent(evt As Integer)
    End Sub
    <System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.Cdecl)>
    Private Shared Sub _EpwReset()
    End Sub
    <System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.Cdecl)>
    Private Shared Function _EpwVpp() As Integer
    End Function
    <System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.Cdecl)>
    Private Shared Function _EpwDRead(mode As Integer, dat As Byte(), len As Integer) As Boolean
    End Function
    <System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention:=System.Runtime.InteropServices.CallingConvention.Cdecl)>
    Private Shared Function _EpwDWrite(mode As Integer, dat As Byte(), len As Integer) As Boolean
    End Function

    Private DataBuff As Byte() = New Byte(255) {}
    Const MODE_BYTE As Integer = 0
    Const MODE_LITTLE As Integer = 1
    Const MODE_BIG As Integer = 2

    Const T_MCW As Integer = 0
    Const T_I2C As Integer = 0
    Const T_SPI As Integer = 0

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        rbMCW.Select()
    End Sub

    Private Sub Mes(str As [String])
        Memo.Text = Memo.Text + str + vbCr & vbLf

    End Sub

    Private Sub Dump(dat As Byte(), len As Integer, endian As Integer)
        Dim tdat As Integer, adr As Integer, lcnt As Integer
        Dim lstr As [String]
        adr = 0
        While adr < len
            lcnt = 0
            lstr = adr.ToString("X4") + ": "
            For lcnt = 0 To 7
                Select Case endian
                    Case MODE_BYTE
                        tdat = dat(adr)
                        lstr += tdat.ToString("X2") + " "
                        tdat = dat(adr + 1)
                        lstr += tdat.ToString("X2") + " "
                        Exit Select
                    Case MODE_LITTLE
                        tdat = dat(adr + 1) * 256 + dat(adr)
                        lstr += tdat.ToString("X4") + " "
                        Exit Select
                    Case MODE_BIG
                        tdat = dat(adr) * 256 + dat(adr + 1)
                        lstr += tdat.ToString("X4") + " "
                        Exit Select
                End Select
                If lcnt = 3 Then
                    lstr += "- "
                End If
                adr += 2
            Next
            Mes(lstr)
        End While

    End Sub


    Private Function GetSelectDevice() As Integer
        Dim RadioButtonChecked_InGroup = DeviceSelect.Controls.OfType(Of RadioButton)().SingleOrDefault(Function(rb) rb.Checked = True)

        ' 結果
        Select Case RadioButtonChecked_InGroup.Name
            Case "rbMCW"
                Return 0
            Case "rbI2C"
                Return 1
            Case "rbSPI"
                Return 2

        End Select
        Return -1
    End Function


    Private Sub ClearButton_Click(sender As Object, e As EventArgs) Handles ClearButton.Click
        Memo.Text = ""

    End Sub

    Private Sub ReadButton_Click(sender As Object, e As EventArgs) Handles ReadButton.Click
        'Read
        Dim devtype As Integer() = New Integer(2) {1, 2, 1}
        'D93C46,D24C02,D25C020
        Dim romsize As Integer() = New Integer(2) {128, 256, 256}
        ' D93C46_SIZE, D24C02_SIZE, D25C020_SIZE 
        Dim devmode As Integer = GetSelectDevice()
        '0:MCW,1:I2C,2:SPI
        Dim endian As Integer

        If Not _EpwOpen(devmode, 0, 50, False) Then
            'ExtMode=default,WriteTime=50ms
            Mes("接続失敗")
            Return
        End If
        If _EpwCheck() = 0 Then
            Mes("デバイスが見つかりません。")
            _EpwClose()
            Return
        End If
        Mes("接続成功")

        If Not _EpwRead(devtype(devmode), 0, DataBuff, romsize(devmode), 0) Then
            'Address=0,PgaeSize=0(AUTO)
            Mes("読出しエラーが発生しました。")
        Else
            If devmode = T_MCW Then
                endian = MODE_BIG
            Else
                endian = MODE_BYTE
            End If
            Dump(DataBuff, romsize(devmode), endian)
            Mes("読出し完了")
        End If

        _EpwClose()
        Mes("切断完了")
    End Sub

    Private Sub WriteButton_Click(sender As Object, e As EventArgs) Handles WriteButton.Click
        'Write
        Dim devtype As Integer() = New Integer(2) {1, 2, 1}
        'D93C46,D24C02,D25C020
        Dim romsize As Integer() = New Integer(2) {128, 256, 256}
        ' D93C46_SIZE, D24C02_SIZE, D25C020_SIZE 
        Dim devmode As Integer = GetSelectDevice()
        '0:MCW,1:I2C,2:SPI
        Dim i As Integer, endian As Integer, page As Integer

        If Not _EpwOpen(devmode, 0, 50, False) Then
            'ExtMode=default,WriteTime=50ms
            Mes("接続失敗")
            Return
        End If
        If _EpwCheck() = 0 Then
            Mes("デバイスが見つかりません。")
            _EpwClose()
            Return
        End If
        Mes("接続成功")

        If devmode = T_MCW Then
            endian = MODE_BIG
            page = 2
        Else
            endian = MODE_BYTE
            page = 1
        End If
        For i = 0 To romsize(devmode) - 1
            DataBuff(i) = CByte(i)
        Next
        Mes("書き込みデータ:")
        Dump(DataBuff, romsize(devmode), endian)
        If Not _EpwWrite(devtype(devmode), 0, DataBuff, romsize(devmode), page) Then
            'Address=0
            Mes("書き込みエラーが発生しました。")
        Else
            Mes("書き込み完了")
        End If
        _EpwClose()
        Mes("切断完了")

    End Sub

    Private Sub EraseButton_Click(sender As Object, e As EventArgs) Handles EraseButton.Click
        'Erase
        Dim devtype As Integer() = New Integer(2) {1, 2, 1}
        'D93C46,D24C02,D25C020
        Dim romsize As Integer() = New Integer(2) {128, 256, 256}
        ' D93C46_SIZE, D24C02_SIZE, D25C020_SIZE 
        Dim devmode As Integer = GetSelectDevice()
        '0:MCW,1:I2C,2:SPI
        Dim page As Integer

        If Not _EpwOpen(devmode, 0, 50, False) Then
            'ExtMode=default,WriteTime=50ms
            Mes("接続失敗")
            Return
        End If
        If _EpwCheck() = 0 Then
            Mes("デバイスが見つかりません。")
            _EpwClose()
            Return
        End If
        Mes("接続成功")
        If devmode = T_MCW Then
            page = 2
        Else
            page = 1
        End If
        If Not _EpwErase(devtype(devmode), 0, DataBuff, romsize(devmode), page) Then
            'Address=0
            Mes("消去エラーが発生しました。")
        Else
            Mes("消去完了")
        End If
        _EpwClose()
        Mes("切断完了")

    End Sub
End Class
